#ifndef __GEOM_UTIL_H__
#define __GEOM_UTIL_H__

#include "types.h"

real_type pointTriangleSqDistance( const real3_type &p, const real3_type &t0, const real3_type &t1, const real3_type &t2, real3_type &closestPoint );
real_type pointBoxSqDistance ( const real3_type &p, const real3_type &boxMin, const real3_type &boxMax, real3_type &closestPoint );
real_type lowerBoundTriangleSqDistance( const real3_type &p, const real3_type &t0, const real3_type &t1, const real3_type &t2 );

#endif
