#include "viewer.h"
#include <QApplication>
#include <libXMLParam/xmlParam.h>
#include "scene.h"
#include "FindCorrespondence.h"
//#include <vtk-5.0/vtkQuadricDecimation.h>
//#include <vtk-5.0/vtkOBJReader.h>
//#include <vtk-5.0/vtkPolyDataWriter.h>
//#include <vtk-5.0/vtkTriangleFilter.h>
//#include <vtk-5.0/vtkCellArray.h>

using namespace std;

int main(int argc, char *argv[])
{
	////////////////////////////////////////////////////////////////////////////
	//// Median test
	//// Compute median length of all edges
	//std::vector<float> edgeLengths;
	//float sampleResolution;

	//edgeLengths.push_back(5.0);
	//edgeLengths.push_back(5.0);
	//edgeLengths.push_back(5.0);
	//edgeLengths.push_back(4.0);
	//edgeLengths.push_back(3.0);
	//edgeLengths.push_back(2.0);
	//edgeLengths.push_back(1.0);
	//edgeLengths.push_back(0.0);

	//cout << "Edge lengths:";
	//for (index_type i = 0; i < edgeLengths.size(); i++) {
	//	cout << " " << edgeLengths[i];
	//}
	//cout << endl;

	//int totalEdges = edgeLengths.size();
	//int medianIndex = ceil((((double)totalEdges) - 1.0) / 2.0);
	//std::partial_sort(edgeLengths.begin(), edgeLengths.begin() + medianIndex + 1, edgeLengths.end());

	//cout << "After sorted edge lengths:";
	//for (index_type i = 0; i < edgeLengths.size(); i++) {
	//	cout << " " << edgeLengths[i];
	//}
	//cout << endl;

	//cout << "size: " << totalEdges << endl;
	//cout << "median index: " << medianIndex << endl;

	//if (totalEdges % 2 == 0) {
	//	// If even, then average the two medians
	//	sampleResolution = (edgeLengths[medianIndex] + edgeLengths[medianIndex-1]) / 2.0;
	//}
	//else {
	//	sampleResolution = edgeLengths[medianIndex];
	//}

	//cout << "****** Mesh resolution: " << sampleResolution << endl;
	//return 0;

	//////////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////
	//// VTK test
	//// load polygonal mesh
	//vtkOBJReader *poly = vtkOBJReader::New();
	//poly->SetFileName("010.obj");
	//vtkPolyData *polyData = poly->GetOutput();

	//// convert polygonal mesh into triangle mesh
	//vtkTriangleFilter *tri = vtkTriangleFilter::New();
	//tri->SetInput(polyData);
	//vtkPolyData *triData = tri->GetOutput();


	//// decimate triangle
	////vtkQuadricClustering *decimate = vtkQuadricClustering::New();
	////decimate->SetNumberOfXDivisions(32);
	////decimate->SetNumberOfYDivisions(32);
	////decimate->SetNumberOfZDivisions(32);
	//vtkQuadricDecimation *decimate = vtkQuadricDecimation::New();
	//decimate->SetTargetReduction(0.99);
	//decimate->SetInput(triData);
	//vtkPolyData *decimateData = decimate->GetOutput();

	//// Perform decimation
	//decimate->Update();

	//cout << "Original triangle mesh: " << triData->GetNumberOfPoints() << " vertices, " << triData->GetNumberOfCells() << " triangles." << endl;
	//cout << "Decimated triangle mesh: " << decimateData->GetNumberOfPoints() << " vertices, " << decimateData->GetNumberOfCells() << " triangles." << endl;

	//// Output list of points and triangles
	//for (int i = 0; i < decimateData->GetNumberOfPoints(); i++) {
	//	double data[3];
	//	decimateData->GetPoint(i, data);
	//	Geometry::Vec3f v(data[0],data[1],data[2]);
	//	cout << "Point " << i << ": " << v << endl;
	//}

	//int *data = new int[10];
	//int numData = 0;
	//for (int i = 0; i < decimateData->GetNumberOfCells(); i++) {
	//	decimateData->GetCellPoints(i, numData, data);

	//	if (numData >= 3) {
	//		Geometry::Vec3i v(data[0],data[1],data[2]);
	//		cout << "Triangle " << i << ": " << v << endl;
	//	}
	//	else {
	//		cout << "****Not a triangle at index " << i << ", numData is " << numData << endl;
	//	}
	//}

	//vtkPolyDataWriter *out = vtkPolyDataWriter::New();
	//out->SetFileName("010_decimate.vtk");
	//out->SetInput(decimateData);
	//out->Write();

	//return 0;

	//////////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////
	//// Test for fitting a sphere
	//PointList pts, normals;
	//real3_type center(1,1,1);
	//real_type radSq = 9;
	////pts.add(real3_type(1.100000,0.200000,0.300000));
	////pts.add(real3_type(0.100000,1.200000,0.300000));
	////pts.add(real3_type(0.100000,0.200000,1.300000));
	////pts.add(real3_type(-0.900000,0.200000,0.300000));
	////pts.add(real3_type(0.100000,-0.800000,0.300000));
	////pts.add(real3_type(0.100000,0.200000,-0.700000));
	////normals.add(real3_type(1.000000,0.000000,0.000000));
	////normals.add(real3_type(0.000000,1.000000,0.000000));
	////normals.add(real3_type(0.000000,0.000000,1.000000));
	////normals.add(real3_type(-1.000000,0.000000,0.000000));
	////normals.add(real3_type(0.000000,-1.000000,0.000000));
	////normals.add(real3_type(0.000000,0.000000,-1.000000));

	//pts.add(real3_type(0.827822,0.854319,0.520774));
	//pts.add(real3_type(0.362909,0.267103,1.053056));
	//pts.add(real3_type(1.044558,0.479331,0.933272));

	//normals.add(real3_type(0.571877,0.731438,0.392965));
	//normals.add(real3_type(0.174808,0.185102,0.974255));
	//normals.add(real3_type(0.602677,0.150029,0.794969));

	//FitSphere(pts, normals, center, radSq);
	//return 0;

	//////////////////////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////
	QApplication a(argc, argv);
	xmlParam par;

	// Instantiate the scene.
	Scene scene;
	scene.setXMLParamList(par);

	// Check input parameters.
	if (par.initParamXML(argc, argv)) {
		std::cout << "-------------------------------------------------------------------------------" << std::endl;
		par.printParamsINI();
		std::cout << "-------------------------------------------------------------------------------" << std::endl;

		// Instantiate the viewer.
		Viewer viewer(&scene);
		viewer.setWindowTitle("shapeAlign");
		viewer.show();
		
		// Start the application.
		return a.exec();
	}

	// Return an error.
	return 1;
}

void setXMLParamList(xmlParam &p) {
	// populate the parameter list with your desired global variables
	//p.addParam("endFrame", "int", (void*)&endFrame);
	//p.addParam("exposure", "float", (void*)&exposure);
	//p.addParam("basePath", "string", (void*)&basePath);
}