#ifndef __COLORMAP_H__
#define __COLORMAP_H__

#include <types.h>

class Colormap {
public:
	Colormap();

	bool save( const char *str );
	bool load( const char *str );

	RealColor getColor( real_type x ) const;

private:
	void makeDefault();

	std::vector<real_type> CtrlPts;
	std::vector<RealColor> CtrlColor;
};

#endif
